分布式计算和集中式计算是完全等价的。将分布式算法中的本地观测  
$$
b_i(k) = \sum_j a_{ij} x_j(k)
$$
代入瑞利商公式  
$$
y(k) = \frac{\sum_i x_i(k) b_i(k)}{\sum_i x_i(k)^2}
$$
即可得到集中式计算的Rayleigh商形式  
$$
\frac{x(k)^T (A x(k))}{x(k)^T x(k)},
$$
这与特征值估计的幂迭代公式  
$$
\lambda_{\max} \approx \frac{x^T A x}{x^T x}
$$
完全一致。

---

### 代数示例

考虑一个简单的2×2矩阵  
$$
A = \begin{pmatrix}2 & 1\\1 & 2\end{pmatrix}, \quad x = \begin{pmatrix}2\\1\end{pmatrix}.
$$

1. **集中式计算**  
$$
\lambda \approx \frac{x^T A x}{x^T x} 
= \frac{\begin{pmatrix}2 & 1\end{pmatrix} \begin{pmatrix}5\\4\end{pmatrix}}{2^2 + 1^2} 
= \frac{10 + 4}{5} 
= \frac{14}{5} = 2.8.
$$

2. **分布式计算**  
各节点分别计算本地观测值  
$$
b_1 = (2 \cdot 2 + 1 \cdot 1) = 5, \quad b_2 = (1 \cdot 2 + 2 \cdot 1) = 4,
$$
然后通过全网共识计算  
$$
y = \frac{2 \cdot 5 + 1 \cdot 4}{2^2 + 1^2} 
= \frac{14}{5} = 2.8.
$$

两种方法得到的结果完全相同。